#!/usr/bin/env python2.6

# boats game by cedstone (c) 2013 (aka Binky)

import pygame
import time
import random
import math
import os

os.chdir(os.path.dirname(os.path.realpath(__file__)))

winsize = (800, 480)
winname = 'Boats'
window = pygame.display.set_mode(winsize)
pygame.display.set_caption(winname)

riverbed = pygame.image.load("riverbed.png")
water = pygame.image.load("water.png")
water = water.convert_alpha()
shore = pygame.image.load("shore.png")
shore = shore.convert_alpha()

notclosed = True
watery = 0
shorey = 0

class duck:
    global winsize
    def __init__(self):
        self.x = random.randint(200, 600)
        self.y = 0
        self.image = pygame.image.load("duck.png")
        self.image = self.image.convert_alpha()
        
    def display(self):
        window.blit(self.image, (self.x, self.y))

    def move(self):
        if self.y<=winsize[1]:
            self. y += random.randint(0, 3) + int(score / 5)
        else:
            self.randomnew()

        if random.randint(0, 100) > 99 :
               self.image = pygame.transform.flip(self.image, True, False)
        if random.randint(0, 100) > 75 :
               self.x += random.randint(-3, 3)      

    def randomnew(self):
        self.x = random.randint(200, 600)
        self.y = -20

class boat:
    def __init__(self):
        self.x = 400
        self.y = 300
        self.angle = 0
        self.trail = []
        self.traillength = 20
        self.masterimage = pygame.image.load("boat.png")
        self.masterimage = self.masterimage.convert_alpha()
        self.image = self.masterimage

    def move(self):
        self.x += self.angle / 4
        if self.x < 150:
            self.x = 153
        if self.x > 520:
            self.x = 513        
        self.trail.append((self.x+50, self.y+70))

    def display(self):
        window.blit(self.image, (self.x, self.y))

    def displaywake(self):
        i = 1
        while i < self.traillength and i < len(self.trail):
            pygame.draw.circle(window, (185, 190, 220), (self.trail[-i][0] + random.randint(-i, i), self.trail[-i][1] + (5*i) + random.randint(-i/2, i/2)), 2, 1)
            pygame.draw.circle(window, (180, 185, 220), (self.trail[-i][0] + random.randint(-i, i), self.trail[-i][1] + (5*i) + random.randint(-i/2, i/2)), 2, 1)   
            pygame.draw.circle(window, (175, 200, 220), (self.trail[-i][0] + random.randint(-i, i), self.trail[-i][1] + (5*i) + random.randint(-i/2, i/2)), 2, 1)
            i = i + 1

    def steerright(self):
        self.angle += 1
        self.image = pygame.transform.rotate(self.masterimage, -self.angle)
        if self.angle > 10:
            self.angle = 10   

    def steerleft(self):
        self.angle -= 1
        self.image = pygame.transform.rotate(self.masterimage, -self.angle)
        if self.angle < -10:
            self.angle = -10   

ducks = [duck(), duck(), duck(), duck(), duck(), duck(), duck(), duck(), duck(), duck()]
boat = boat()

score = 0.0


def explosion (x, y, s):
    x = int(x)
    y = int(y)
    pygame.draw.circle(window, (255, 128, 0), (x, y), 2*s, 0)
    pygame.draw.circle(window, (255, 255, 255), (x, y), 3*s, 1)
    pygame.draw.circle(window, (255, 255, 0), (x, y), 5*s, 1)

while notclosed:  
    time.sleep(0.01)
    pygame.display.flip()
    
    window.blit(riverbed, (0, shorey))
    window.blit(riverbed, (0, shorey-winsize[1]))
    boat.displaywake()
    window.blit(water, (0, watery))
    window.blit(water, (0, watery-winsize[1]))
    score += 0.005
   # print(int(score))
    i = 0
    while i < len(ducks):
        ducks[i].move()
        ducks[i].display()
        if (ducks[i].x > (boat.x + 25)) and (ducks[i].x < (boat.x + 75)) and (ducks[i].y > (boat.y)) and (ducks[i].y < (boat.y + 100)) :
            explosion(ducks[i].x, ducks[i].y, random.randint(5, 15))
            ducks[i].randomnew()
            score -=1
           # time.sleep(1)
            #notclosed = False
        i += 1
    
    boat.display()
    boat.move()
    
    window.blit(shore, (0, shorey))
    window.blit(shore, (0, shorey-winsize[1]))
    
    if watery <winsize[1]:
        watery+=2 + int(score / 5)
    else:
        watery = 0
        
    if shorey <winsize[1]:
        shorey+=1 + int(score / 5)
    else:
        shorey = 0

    
    i = 0
    while i < score:
        pygame.draw.rect(window, (250, 0, 0), ((int(10*i), 470), (int(10*(i+1)), 480)), 0)
        i += 1
        
        
    for event in pygame.event.get():  
        if event.type == pygame.KEYDOWN:
            if event.key == pygame.K_RIGHT:
                boat.steerright()
            if event.key == pygame.K_LEFT:
                boat.steerleft()
        if event.type == pygame.QUIT:
            notclosed = False
            print('Exiting...')